<?php
error_reporting(E_ALL | E_STRICT);
ini_set("track_errors", "On");

$INC = "../inc";
require_once($INC . "/init.inc.php");
require_once($INC . "/log.inc.php");
require_once($INC . "/sql.inc.php");
require_once($INC . "/struct.inc.php");
require_once($INC . "/state.inc.php");

rg_log_set_file("state.log");

$rg_sql_debug = 1;
$rg_lock_dir = ".";

$db = rg_sql_open("dbname=trg");
if ($db === FALSE) {
	echo "Cannot create a database (" . rg_sql_error() . ")!\n";
	exit(1);
}

$r = rg_state_set($db, "schema_version", "0");
if ($r !== TRUE) {
	echo "Cannot reset schema (" . rg_state_error() . ")!\n";
	exit(1);
}

$r = rg_sql_struct_update($db, RG_DROP_TABLES);
if ($r !== TRUE) {
	echo "Cannot create structure (" . rg_sql_error() . ")!\n";
	exit(1);
}

// check return for an invalid state
$r = rg_state_get($db, "asdsdsdf");
if ($r !== "") {
	echo "Cannot get '' (but '$r') for an unknown key!\n";
	exit(1);
}

$r = rg_state_set($db, "a", "bau");
if ($r !== TRUE) {
	echo "Cannot get a TRUE for setting 'a' to 'bau' ($r)!\n";
	exit(1);
}

$r = rg_state_set($db, "a", "cucu");
if ($r !== TRUE) {
	echo "Cannot get a TRUE for setting 'a' to 'cucu' ($r)!\n";
	exit(1);
}

$r = rg_state_get($db, "a");
if (strcmp($r, "cucu") != 0) {
	echo "Cannot get correct state ('$r' != 'cucu')!\n";
	exit(1);
}

rg_sql_close($db);

echo "state: OK!\n";
?>
